#

API Docs for: v2.11.1
Show: Inherited Protected Private Deprecated

# Ember.Enumerable Class

Defined in: `packages/ember-runtime/lib/mixins/enumerable.js:58`
Module: ember-runtime
Parent Module: ember

Available since Ember 0.9

This mixin defines the common interface implemented by enumerable objects in Ember. Most of these methods follow the standard Array iteration API defined up to JavaScript 1.8 (excluding language-specific features that cannot be emulated in older versions of JavaScript).

This mixin is applied automatically to the Array class on page load, so you can use any of these methods on simple arrays. If Array already implements one of these methods, the mixin will not override them.

## Writing Your Own Enumerable

To make your own custom class enumerable, you need two items:

1. You must have a length property. This property should change whenever the number of items in your enumerable object changes. If you use this with an `Ember.Object` subclass, you should be sure to change the length property using `set().`

2. You must implement `nextObject().` See documentation.

Once you have these two methods implemented, apply the `Ember.Enumerable` mixin to your class and you will be able to enumerate the contents of your object like any other collection.

## Using Ember Enumeration with Other Libraries

Many other libraries provide some kind of iterator or enumeration like facility. This is often where the most common API conflicts occur. Ember's API is designed to be as friendly as possible with other libraries by implementing only methods that mostly correspond to the JavaScript 1.8 API.

- Index
- Methods
- Properties

## Item Index

### Methods

- addEnumerableObserver
- any
- compact
- contains deprecated
- enumerableContentDidChange
- enumerableContentWillChange
- every
- filter
- filterBy
- find
- findBy
- forEach
- getEach
- includes
- invoke
- isAny
- isEvery
- map
- mapBy
- nextObject
- reduce
- reject
- rejectBy
- removeEnumerableObserver
- setEach
- sortBy
- toArray
- uniq
- uniqBy
- without

### Properties

- []
- firstObject
- hasEnumerableObservers
- lastObject

## Methods

### `addEnumerableObserver`

(

- `target`
- `[opts]`

)
private

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:866`

Registers an enumerable observer. Must implement `Ember.EnumerableObserver` mixin.

#### Parameters:

- `target` Object
- `[opts]` Object optional

#### Returns:

this

### `any`

(

- `callback`
- `[target]`

)
Boolean public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:608`

Returns `true` if the passed function returns true for any item in the enumeration. This corresponds with the `some()` method in JavaScript 1.6.

The callback method you provide should have the following signature (all parameters are optional):

    function(item, index, enumerable);

- `item` is the current item in the iteration.
- `index` is the current index in the iteration.
- `enumerable` is the enumerable object itself.

It should return the `true` to include the item in the results, `false` otherwise.

Note that in addition to a callback, you can also pass an optional target object that will be set as `this` on the context. This is a good way to give your iterator function access to the current object.

Usage Example:

    if (people.any(isManager)) {
      Paychecks.addBiggerBonus();
    }

#### Parameters:

- `callback` Function

  The callback to execute

- `[target]` Object optional

  The target object to use

#### Returns:

Boolean:

`true` if the passed function returns `true` for any item

### `compact`

() Array public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:771`

Returns a copy of the array with all `null` and `undefined` elements removed.

    let arr = ['a', null, 'c', undefined];
    arr.compact();  // ['a', 'c']

#### Returns:

Array:

the array without null and undefined elements.

### `contains`

(

- `obj`

)
Boolean deprecated public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:213`

Deprecated: Use `Enumerable#includes` instead. See http://emberjs.com/deprecations/v2.x#toc_enumerable-contains

Returns `true` if the passed object can be found in the receiver. The default version will iterate through the enumerable until the object is found. You may want to override this with a more efficient version.

    let arr = ['a', 'b', 'c'];

    arr.contains('a'); // true
    arr.contains('z'); // false

#### Parameters:

- `obj` Object

  The object to search for.

#### Returns:

Boolean:

`true` if object is found in enumerable.

### `enumerableContentDidChange`

(

- `removing`
- `adding`

)
private chainable

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:989`

Invoke this method when the contents of your enumerable has changed. This will notify any observers watching for content changes. If you are implementing an ordered enumerable (such as an array), also pass the start and end values where the content changed so that it can be used to notify range observers.

#### Parameters:

- `removing` Ember.Enumerable | Number

  An enumerable of the objects to be removed or the number of items to be removed.

- `adding` Ember.Enumerable | Number

  An enumerable of the objects to be added or the number of items to be added.

### `enumerableContentWillChange`

(

- `removing`
- `adding`

)
private chainable

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:936`

Invoke this method just before the contents of your enumerable will change. You can either omit the parameters completely or pass the objects to be removed or added if available or just a count.

#### Parameters:

- `removing` Ember.Enumerable | Number

  An enumerable of the objects to be removed or the number of items to be removed.

- `adding` Ember.Enumerable | Number

  An enumerable of the objects to be added or the number of items to be added.

### `every`

(

- `callback`
- `[target]`

)
Boolean public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:553`

Returns `true` if the passed function returns true for every item in the enumeration. This corresponds with the `every()` method in JavaScript 1.6.

The callback method you provide should have the following signature (all parameters are optional):

    function(item, index, enumerable);

- `item` is the current item in the iteration.
- `index` is the current index in the iteration.
- `enumerable` is the enumerable object itself.

It should return the `true` or `false`.

Note that in addition to a callback, you can also pass an optional target object that will be set as `this` on the context. This is a good way to give your iterator function access to the current object.

Example Usage:

    if (people.every(isEngineer)) {
      Paychecks.addBigBonus();
    }

#### Parameters:

- `callback` Function

  The callback to execute

- `[target]` Object optional

  The target object to use

#### Returns:

Boolean:

### `filter`

(

- `callback`
- `[target]`

)
Array public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:370`

Returns an array with all of the items in the enumeration that the passed function returns true for. This method corresponds to `filter()` defined in JavaScript 1.6.

The callback method you provide should have the following signature (all parameters are optional):

    function(item, index, enumerable);

- `item` is the current item in the iteration.
- `index` is the current index in the iteration.
- `enumerable` is the enumerable object itself.

It should return `true` to include the item in the results, `false` otherwise.

Note that in addition to a callback, you can also pass an optional target object that will be set as `this` on the context. This is a good way to give your iterator function access to the current object.

#### Parameters:

- `callback` Function

  The callback to execute

- `[target]` Object optional

  The target object to use

#### Returns:

Array:

A filtered array.

### `filterBy`

(

- `key`
- `[value]`

)
Array public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:444`

Returns an array with just the items with the matched property. You can pass an optional second argument with the target value. Otherwise this will match any property that evaluates to `true`.

#### Parameters:

- `key` String

  the property to test

- `[value]` optional

  optional value to test against.

#### Returns:

Array:

filtered array

### `find`

(

- `callback`
- `[target]`

)
Object public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:478`

Returns the first item in the array for which the callback returns true. This method works similar to the `filter()` method defined in JavaScript 1.6 except that it will stop working on the array once a match is found.

The callback method you provide should have the following signature (all parameters are optional):

    function(item, index, enumerable);

- `item` is the current item in the iteration.
- `index` is the current index in the iteration.
- `enumerable` is the enumerable object itself.

It should return the `true` to include the item in the results, `false` otherwise.

Note that in addition to a callback, you can also pass an optional target object that will be set as `this` on the context. This is a good way to give your iterator function access to the current object.

#### Parameters:

- `callback` Function

  The callback to execute

- `[target]` Object optional

  The target object to use

#### Returns:

Object:

Found item or `undefined`.

### `findBy`

(

- `key`
- `[value]`

)
Object public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:536`

Returns the first item with a property matching the passed value. You can pass an optional second argument with the target value. Otherwise this will match any property that evaluates to `true`.

This method works much like the more generic `find()` method.

#### Parameters:

- `key` String

  the property to test

- `[value]` String optional

  optional value to test against.

#### Returns:

Object:

found item or `undefined`

### `forEach`

(

- `callback`
- `[target]`

)
Object public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:245`

Iterates through the enumerable, calling the passed function on each item. This method corresponds to the `forEach()` method defined in JavaScript 1.6.

The callback method you provide should have the following signature (all parameters are optional):

    function(item, index, enumerable);

- `item` is the current item in the iteration.
- `index` is the current index in the iteration.
- `enumerable` is the enumerable object itself.

Note that in addition to a callback, you can also pass an optional target object that will be set as `this` on the context. This is a good way to give your iterator function access to the current object.

#### Parameters:

- `callback` Function

  The callback to execute

- `[target]` Object optional

  The target object to use

#### Returns:

Object:

receiver

### `getEach`

(

- `key`

)
Array public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:296`

Alias for `mapBy`

#### Parameters:

- `key` String

  name of the property

#### Returns:

Array:

The mapped array.

### `includes`

(

- `obj`

)
Boolean public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:1112`

Returns `true` if the passed object can be found in the enumerable.

    [1, 2, 3].includes(2);                     // true
    [1, 2, 3].includes(4);                     // false
    [1, 2, undefined].includes(undefined);     // true
    [1, 2, null].includes(null);               // true
    [1, 2, NaN].includes(NaN);                 // true

#### Parameters:

- `obj` Object

  The object to search for.

#### Returns:

Boolean:

`true` if object is found in the enumerable.

### `invoke`

(

- `methodName`
- `args`

)
Array public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:730`

Invokes the named method on every object in the receiver that implements it. This method corresponds to the implementation in Prototype 1.6.

#### Parameters:

- `methodName` String

  the name of the method

- `args` Object...

  optional arguments to pass as well.

#### Returns:

Array:

return values from calling invoke.

### `isAny`

(

- `key`
- `[value]`

)
Boolean public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:666`

Available since 1.3.0

Returns `true` if the passed property resolves to the value of the second argument for any item in the enumerable. This method is often simpler/faster than using a callback.

#### Parameters:

- `key` String

  the property to test

- `[value]` String optional

  optional value to test against. Defaults to `true`

#### Returns:

Boolean:

### `isEvery`

(

- `key`
- `[value]`

)
Boolean public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:592`

Available since 1.3.0

Returns `true` if the passed property resolves to the value of the second argument for all items in the enumerable. This method is often simpler/faster than using a callback.

#### Parameters:

- `key` String

  the property to test

- `[value]` String optional

  optional value to test against. Defaults to `true`

#### Returns:

Boolean:

### `map`

(

- `callback`
- `[target]`

)
Array public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:322`

Maps all of the items in the enumeration to another value, returning a new array. This method corresponds to `map()` defined in JavaScript 1.6.

The callback method you provide should have the following signature (all parameters are optional):

    function(item, index, enumerable);

- `item` is the current item in the iteration.
- `index` is the current index in the iteration.
- `enumerable` is the enumerable object itself.

It should return the mapped value.

Note that in addition to a callback, you can also pass an optional target object that will be set as `this` on the context. This is a good way to give your iterator function access to the current object.

#### Parameters:

- `callback` Function

  The callback to execute

- `[target]` Object optional

  The target object to use

#### Returns:

Array:

The mapped array.

### `mapBy`

(

- `key`

)
Array public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:357`

Similar to map, this specialized function returns the value of the named property on all items in the enumeration.

#### Parameters:

- `key` String

  name of the property

#### Returns:

Array:

The mapped array.

### `nextObject`

(

- `index`
- `previousObject`
- `context`

)
Object private

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:98`

Required. You must implement this method to apply this mixin.

Implement this method to make your class enumerable.

This method will be called repeatedly during enumeration. The index value will always begin with 0 and increment monotonically. You don't have to rely on the index value to determine what object to return, but you should always check the value and start from the beginning when you see the requested index is 0.

The `previousObject` is the object that was returned from the last call to `nextObject` for the current iteration. This is a useful way to manage iteration if you are tracing a linked list, for example.

Finally the context parameter will always contain a hash you can use as a "scratchpad" to maintain any other state you need in order to iterate properly. The context object is reused and is not reset between iterations so make sure you setup the context with a fresh state whenever the index parameter is 0.

Generally iterators will continue to call `nextObject` until the index reaches the current length-1. If you run out of data before this time for some reason, you should simply return undefined.

The default implementation of this method simply looks up the index. This works great on any Array-like objects.

#### Parameters:

- `index` Number

  the current index of the iteration

- `previousObject` Object

  the value returned by the last call to `nextObject`.

- `context` Object

  a context object you can use to maintain state.

#### Returns:

Object:

the next object in the iteration or undefined

### `reduce`

(

- `callback`
- `initialValue`
- `reducerProperty`

)
Object public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:682`

This will combine the values of the enumerator into a single value. It is a useful way to collect a summary value from an enumeration. This corresponds to the `reduce()` method defined in JavaScript 1.8.

The callback method you provide should have the following signature (all parameters are optional):

    function(previousValue, item, index, enumerable);

- `previousValue` is the value returned by the last call to the iterator.
- `item` is the current item in the iteration.
- `index` is the current index in the iteration.
- `enumerable` is the enumerable object itself.

Return the new cumulative value.

In addition to the callback you can also pass an `initialValue`. An error will be raised if you do not pass an initial value and the enumerator is empty.

Note that unlike the other methods, this method does not allow you to pass a target object to set as this for the callback. It's part of the spec. Sorry.

#### Parameters:

- `callback` Function

  The callback to execute

- `initialValue` Object

  Initial value for the reduce

- `reducerProperty` String

  internal use only.

#### Returns:

Object:

The reduced value.

### `reject`

(

- `callback`
- `[target]`

)
Array public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:411`

Returns an array with all of the items in the enumeration where the passed function returns false. This method is the inverse of filter().

The callback method you provide should have the following signature (all parameters are optional):

    function(item, index, enumerable);

- item is the current item in the iteration.
- index is the current index in the iteration
- enumerable is the enumerable object itself.

It should return a falsey value to include the item in the results.

Note that in addition to a callback, you can also pass an optional target object that will be set as "this" on the context. This is a good way to give your iterator function access to the current object.

#### Parameters:

- `callback` Function

  The callback to execute

- `[target]` Object optional

  The target object to use

#### Returns:

Array:

A rejected array.

### `rejectBy`

(

- `key`
- `[value]`

)
Array public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:459`

Returns an array with the items that do not have truthy values for key. You can pass an optional second argument with the target value. Otherwise this will match any property that evaluates to false.

#### Parameters:

- `key` String

  the property to test

- `[value]` String optional

  optional value to test against.

#### Returns:

Array:

rejected array

### `removeEnumerableObserver`

(

- `target`
- `[opts]`

)
private

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:895`

Removes a registered enumerable observer.

#### Parameters:

- `target` Object
- `[opts]` Object optional

#### Returns:

this

### `setEach`

(

- `key`
- `value`

)
Object public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:306`

Sets the value on the named property for each member. This is more ergonomic than using other methods defined on this helper. If the object implements Ember.Observable, the value will be changed to `set(),` otherwise it will be set directly. `null` objects are skipped.

#### Parameters:

- `key` String

  The key to set

- `value` Object

  The object to set

#### Returns:

Object:

receiver

### `sortBy`

(

- `property`

)
Array public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:1044`

Available since 1.2.0

Converts the enumerable into an array and sorts by the keys specified in the argument.

You may provide multiple arguments to sort by multiple properties.

#### Parameters:

- `property` String

  name(s) to sort on

#### Returns:

Array:

The sorted array.

### `toArray`

() Array public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:755`

Simply converts the enumerable into a genuine array. The order is not guaranteed. Corresponds to the method implemented by Prototype.

#### Returns:

Array:

the enumerable as an array.

### `uniq`

() Ember.Enumerable public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:818`

Returns a new enumerable that contains only unique values. The default implementation returns an array regardless of the receiver type.

    let arr = ['a', 'a', 'b', 'b'];
    arr.uniq();  // ['a', 'b']

This only works on primitive data types, e.g. Strings, Numbers, etc.

#### Returns:

Ember.Enumerable:

### `uniqBy`

() Ember.Enumerable public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:1079`

Returns a new enumerable that contains only items containing a unique property value. The default implementation returns an array regardless of the receiver type.

    let arr = [{ value: 'a' }, { value: 'a' }, { value: 'b' }, { value: 'b' }];
    arr.uniqBy('value');  // [{ value: 'a' }, { value: 'b' }]

#### Returns:

Ember.Enumerable:

### `without`

(

- `value`

)
Ember.Enumerable public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:787`

Returns a new enumerable that excludes the passed value. The default implementation returns an array regardless of the receiver type. If the receiver does not contain the value it returns the original enumerable.

    let arr = ['a', 'b', 'a', 'c'];
    arr.without('a');  // ['b', 'c']

#### Parameters:

- `value` Object

#### Returns:

Ember.Enumerable:

## Properties

### `[]`

Array private

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:845`

This property will trigger anytime the enumerable's content changes. You can observe this property to be notified of changes to the enumerable's content.

For plain enumerables, this property is read only. `Array` overrides this method.

### `firstObject`

Unknown public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:136`

Helper method returns the first object from a collection. This is usually used by bindings and other parts of the framework to extract a single object if the enumerable contains only one item.

If you override this method, you should implement it so that it will always return the same value each time it is called. If your enumerable contains only one object, this method should always return that object. If your enumerable is empty, this method should return `undefined`.

    let arr = ['a', 'b', 'c'];
    arr.get('firstObject');  // 'a'

    let arr = [];
    arr.get('firstObject');  // undefined

### `hasEnumerableObservers`

Boolean private

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:923`

Becomes true whenever the array currently has observers watching changes on the array.

### `lastObject`

Unknown public

Defined in `packages/ember-runtime/lib/mixins/enumerable.js:173`

Helper method returns the last object from a collection. If your enumerable contains only one object, this method should always return that object. If your enumerable is empty, this method should return `undefined`.

    let arr = ['a', 'b', 'c'];
    arr.get('lastObject');  // 'c'

    let arr = [];
    arr.get('lastObject');  // undefined